package cat.hack3.codingtests.marsrover;

public class MarsRover {
    private final MarsMap marsMap;
    private Direction currentDirection;

    public MarsRover(MarsMap marsMap, Direction startingDirection) {
        this.marsMap = marsMap;
        currentDirection = startingDirection;
    }

    public Coordinates moveForward() {
        return marsMap.updatePositionTowards(currentDirection);
    }

    public Coordinates moveBackwards() {
        return marsMap.updatePositionTowards(currentDirection.reversed());
    }

    public Direction turnLeft() {
        return currentDirection = currentDirection.changeDirectionToLeft();
    }

    public Coordinates getCurrentCoordinates() {
        return marsMap.getCurrentPosition();
    }

    public Direction getCurrentDirection() {
        return currentDirection;
    }
}
